Merge branch 'fc/remote-bzr'
[git.git] / git-rebase.sh
blobb2f1c76dc3ede707870564a8ba73af6d1753e95c
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_SPEC="\
9 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
11 git-rebase --continue | --abort | --skip | --edit-todo
13 Available options are
14 v,verbose! display a diffstat of what changed upstream
15 q,quiet! be quiet. implies --no-stat
16 onto=! rebase onto given branch instead of upstream
17 p,preserve-merges! try to recreate merges instead of ignoring them
18 s,strategy=! use the given merge strategy
19 no-ff! cherry-pick all commits, even if unchanged
20 m,merge! use merging strategies to rebase
21 i,interactive! let the user edit the list of commits to rebase
22 x,exec=! add exec lines after each commit of the editable list
23 k,keep-empty preserve empty commits during rebase
24 f,force-rebase! force rebase even if branch is up to date
25 X,strategy-option=! pass the argument through to the merge strategy
26 stat! display a diffstat of what changed upstream
27 n,no-stat! do not show diffstat of what changed upstream
28 verify allow pre-rebase hook to run
29 rerere-autoupdate allow rerere to update index with resolved conflicts
30 root! rebase all reachable commits up to the root(s)
31 autosquash move commits that begin with squash!/fixup! under -i
32 committer-date-is-author-date! passed to 'git am'
33 ignore-date! passed to 'git am'
34 whitespace=! passed to 'git apply'
35 ignore-whitespace! passed to 'git apply'
36 C=! passed to 'git apply'
37 Actions:
38 continue! continue
39 abort! abort and check out the original branch
40 skip! skip current patch and continue
41 edit-todo! edit the todo list during an interactive rebase
43 . git-sh-setup
44 . git-sh-i18n
45 set_reflog_action rebase
46 require_work_tree_exists
47 cd_to_toplevel
49 LF='
51 ok_to_skip_pre_rebase=
52 resolvemsg="
53 $(gettext 'When you have resolved this problem, run "git rebase --continue".
54 If you prefer to skip this patch, run "git rebase --skip" instead.
55 To check out the original branch and stop rebasing, run "git rebase --abort".')
57 unset onto
58 cmd=
59 strategy=
60 strategy_opts=
61 do_merge=
62 merge_dir="$GIT_DIR"/rebase-merge
63 apply_dir="$GIT_DIR"/rebase-apply
64 verbose=
65 diffstat=
66 test "$(git config --bool rebase.stat)" = true && diffstat=t
67 git_am_opt=
68 rebase_root=
69 force_rebase=
70 allow_rerere_autoupdate=
71 # Non-empty if a rebase was in progress when 'git rebase' was invoked
72 in_progress=
73 # One of {am, merge, interactive}
74 type=
75 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
76 state_dir=
77 # One of {'', continue, skip, abort}, as parsed from command line
78 action=
79 preserve_merges=
80 autosquash=
81 keep_empty=
82 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
84 read_basic_state () {
85 head_name=$(cat "$state_dir"/head-name) &&
86 onto=$(cat "$state_dir"/onto) &&
87 # We always write to orig-head, but interactive rebase used to write to
88 # head. Fall back to reading from head to cover for the case that the
89 # user upgraded git with an ongoing interactive rebase.
90 if test -f "$state_dir"/orig-head
91 then
92 orig_head=$(cat "$state_dir"/orig-head)
93 else
94 orig_head=$(cat "$state_dir"/head)
95 fi &&
96 GIT_QUIET=$(cat "$state_dir"/quiet) &&
97 test -f "$state_dir"/verbose && verbose=t
98 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
99 test -f "$state_dir"/strategy_opts &&
100 strategy_opts="$(cat "$state_dir"/strategy_opts)"
101 test -f "$state_dir"/allow_rerere_autoupdate &&
102 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
105 write_basic_state () {
106 echo "$head_name" > "$state_dir"/head-name &&
107 echo "$onto" > "$state_dir"/onto &&
108 echo "$orig_head" > "$state_dir"/orig-head &&
109 echo "$GIT_QUIET" > "$state_dir"/quiet &&
110 test t = "$verbose" && : > "$state_dir"/verbose
111 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
112 test -n "$strategy_opts" && echo "$strategy_opts" > \
113 "$state_dir"/strategy_opts
114 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
115 "$state_dir"/allow_rerere_autoupdate
118 output () {
119 case "$verbose" in
121 output=$("$@" 2>&1 )
122 status=$?
123 test $status != 0 && printf "%s\n" "$output"
124 return $status
127 "$@"
129 esac
132 move_to_original_branch () {
133 case "$head_name" in
134 refs/*)
135 message="rebase finished: $head_name onto $onto"
136 git update-ref -m "$message" \
137 $head_name $(git rev-parse HEAD) $orig_head &&
138 git symbolic-ref \
139 -m "rebase finished: returning to $head_name" \
140 HEAD $head_name ||
141 die "$(gettext "Could not move back to $head_name")"
143 esac
146 run_specific_rebase () {
147 if [ "$interactive_rebase" = implied ]; then
148 GIT_EDITOR=:
149 export GIT_EDITOR
150 autosquash=
152 . git-rebase--$type
155 run_pre_rebase_hook () {
156 if test -z "$ok_to_skip_pre_rebase" &&
157 test -x "$GIT_DIR/hooks/pre-rebase"
158 then
159 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
160 die "$(gettext "The pre-rebase hook refused to rebase.")"
164 test -f "$apply_dir"/applying &&
165 die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
167 if test -d "$apply_dir"
168 then
169 type=am
170 state_dir="$apply_dir"
171 elif test -d "$merge_dir"
172 then
173 if test -f "$merge_dir"/interactive
174 then
175 type=interactive
176 interactive_rebase=explicit
177 else
178 type=merge
180 state_dir="$merge_dir"
182 test -n "$type" && in_progress=t
184 total_argc=$#
185 while test $# != 0
187 case "$1" in
188 --no-verify)
189 ok_to_skip_pre_rebase=yes
191 --verify)
192 ok_to_skip_pre_rebase=
194 --continue|--skip|--abort|--edit-todo)
195 test $total_argc -eq 2 || usage
196 action=${1##--}
198 --onto)
199 test 2 -le "$#" || usage
200 onto="$2"
201 shift
204 test 2 -le "$#" || usage
205 cmd="${cmd}exec $2${LF}"
206 shift
209 interactive_rebase=explicit
212 keep_empty=yes
215 preserve_merges=t
216 test -z "$interactive_rebase" && interactive_rebase=implied
218 --autosquash)
219 autosquash=t
221 --no-autosquash)
222 autosquash=
224 -M|-m)
225 do_merge=t
228 shift
229 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
230 do_merge=t
231 test -z "$strategy" && strategy=recursive
234 shift
235 strategy="$1"
236 do_merge=t
239 diffstat=
241 --stat)
242 diffstat=t
245 verbose=t
246 diffstat=t
247 GIT_QUIET=
250 GIT_QUIET=t
251 git_am_opt="$git_am_opt -q"
252 verbose=
253 diffstat=
255 --whitespace)
256 shift
257 git_am_opt="$git_am_opt --whitespace=$1"
258 case "$1" in
259 fix|strip)
260 force_rebase=t
262 esac
264 --ignore-whitespace)
265 git_am_opt="$git_am_opt $1"
267 --committer-date-is-author-date|--ignore-date)
268 git_am_opt="$git_am_opt $1"
269 force_rebase=t
272 shift
273 git_am_opt="$git_am_opt -C$1"
275 --root)
276 rebase_root=t
278 -f|--no-ff)
279 force_rebase=t
281 --rerere-autoupdate|--no-rerere-autoupdate)
282 allow_rerere_autoupdate="$1"
285 shift
286 break
288 esac
289 shift
290 done
291 test $# -gt 2 && usage
293 if test -n "$cmd" &&
294 test "$interactive_rebase" != explicit
295 then
296 die "$(gettext "The --exec option must be used with the --interactive option")"
299 if test -n "$action"
300 then
301 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
302 # Only interactive rebase uses detailed reflog messages
303 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
304 then
305 GIT_REFLOG_ACTION="rebase -i ($action)"
306 export GIT_REFLOG_ACTION
310 if test "$action" = "edit-todo" && test "$type" != "interactive"
311 then
312 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
315 case "$action" in
316 continue)
317 # Sanity check
318 git rev-parse --verify HEAD >/dev/null ||
319 die "$(gettext "Cannot read HEAD")"
320 git update-index --ignore-submodules --refresh &&
321 git diff-files --quiet --ignore-submodules || {
322 echo "$(gettext "You must edit all merge conflicts and then
323 mark them as resolved using git add")"
324 exit 1
326 read_basic_state
327 run_specific_rebase
329 skip)
330 output git reset --hard HEAD || exit $?
331 read_basic_state
332 run_specific_rebase
334 abort)
335 git rerere clear
336 read_basic_state
337 case "$head_name" in
338 refs/*)
339 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
340 die "$(eval_gettext "Could not move back to \$head_name")"
342 esac
343 output git reset --hard $orig_head
344 rm -r "$state_dir"
345 exit
347 edit-todo)
348 run_specific_rebase
350 esac
352 # Make sure no rebase is in progress
353 if test -n "$in_progress"
354 then
355 state_dir_base=${state_dir##*/}
356 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
357 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
358 die "
359 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
360 I wonder if you are in the middle of another rebase. If that is the
361 case, please try
362 $cmd_live_rebase
363 If that is not the case, please
364 $cmd_clear_stale_rebase
365 and run me again. I am stopping in case you still have something
366 valuable there.')"
369 if test -n "$rebase_root" && test -z "$onto"
370 then
371 test -z "$interactive_rebase" && interactive_rebase=implied
374 if test -n "$interactive_rebase"
375 then
376 type=interactive
377 state_dir="$merge_dir"
378 elif test -n "$do_merge"
379 then
380 type=merge
381 state_dir="$merge_dir"
382 else
383 type=am
384 state_dir="$apply_dir"
387 if test -z "$rebase_root"
388 then
389 case "$#" in
391 if ! upstream_name=$(git rev-parse --symbolic-full-name \
392 --verify -q @{upstream} 2>/dev/null)
393 then
394 . git-parse-remote
395 error_on_missing_default_upstream "rebase" "rebase" \
396 "against" "git rebase <branch>"
399 *) upstream_name="$1"
400 shift
402 esac
403 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
404 die "$(eval_gettext "invalid upstream \$upstream_name")"
405 upstream_arg="$upstream_name"
406 else
407 if test -z "$onto"
408 then
409 empty_tree=`git hash-object -t tree /dev/null`
410 onto=`git commit-tree $empty_tree </dev/null`
411 squash_onto="$onto"
413 unset upstream_name
414 unset upstream
415 test $# -gt 1 && usage
416 upstream_arg=--root
419 # Make sure the branch to rebase onto is valid.
420 onto_name=${onto-"$upstream_name"}
421 case "$onto_name" in
422 *...*)
423 if left=${onto_name%...*} right=${onto_name#*...} &&
424 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
425 then
426 case "$onto" in
427 ?*"$LF"?*)
428 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
431 die "$(eval_gettext "\$onto_name: there is no merge base")"
433 esac
434 else
435 die "$(eval_gettext "\$onto_name: there is no merge base")"
439 onto=$(git rev-parse --verify "${onto_name}^0") ||
440 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
442 esac
444 # If the branch to rebase is given, that is the branch we will rebase
445 # $branch_name -- branch being rebased, or HEAD (already detached)
446 # $orig_head -- commit object name of tip of the branch before rebasing
447 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
448 switch_to=
449 case "$#" in
451 # Is it "rebase other $branchname" or "rebase other $commit"?
452 branch_name="$1"
453 switch_to="$1"
455 if git show-ref --verify --quiet -- "refs/heads/$1" &&
456 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
457 then
458 head_name="refs/heads/$1"
459 elif orig_head=$(git rev-parse -q --verify "$1")
460 then
461 head_name="detached HEAD"
462 else
463 die "$(eval_gettext "fatal: no such branch: \$branch_name")"
467 # Do not need to switch branches, we are already on it.
468 if branch_name=`git symbolic-ref -q HEAD`
469 then
470 head_name=$branch_name
471 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
472 else
473 head_name="detached HEAD"
474 branch_name=HEAD ;# detached
476 orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
479 die "BUG: unexpected number of arguments left to parse"
481 esac
483 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
485 # Now we are rebasing commits $upstream..$orig_head (or with --root,
486 # everything leading up to $orig_head) on top of $onto
488 # Check if we are already based on $onto with linear history,
489 # but this should be done only when upstream and onto are the same
490 # and if this is not an interactive rebase.
491 mb=$(git merge-base "$onto" "$orig_head")
492 if test "$type" != interactive && test "$upstream" = "$onto" &&
493 test "$mb" = "$onto" &&
494 # linear history?
495 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
496 then
497 if test -z "$force_rebase"
498 then
499 # Lazily switch to the target branch if needed...
500 test -z "$switch_to" || git checkout "$switch_to" --
501 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
502 exit 0
503 else
504 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
508 # If a hook exists, give it a chance to interrupt
509 run_pre_rebase_hook "$upstream_arg" "$@"
511 if test -n "$diffstat"
512 then
513 if test -n "$verbose"
514 then
515 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
517 # We want color (if set), but no pager
518 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
521 test "$type" = interactive && run_specific_rebase
523 # Detach HEAD and reset the tree
524 say "$(gettext "First, rewinding head to replay your work on top of it...")"
525 git checkout -q "$onto^0" || die "could not detach HEAD"
526 git update-ref ORIG_HEAD $orig_head
528 # If the $onto is a proper descendant of the tip of the branch, then
529 # we just fast-forwarded.
530 if test "$mb" = "$orig_head"
531 then
532 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
533 move_to_original_branch
534 exit 0
537 if test -n "$rebase_root"
538 then
539 revisions="$onto..$orig_head"
540 else
541 revisions="$upstream..$orig_head"
544 run_specific_rebase